Bug Hunting Session
Bug 76017 - Two Finger Horizontal Scroll is Reversed with Synaptics Touchpad Drivers on Windows
Summary: Two Finger Horizontal Scroll is Reversed with Synaptics Touchpad Drivers on W...
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
4.2.0.4 release
Hardware: x86-64 (AMD64) Windows (All)
: medium normal
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: Scrolling-PageUpDown
  Show dependency treegraph
 
Reported: 2014-03-11 09:11 UTC by roee
Modified: 2019-09-02 10:02 UTC (History)
13 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description roee 2014-03-11 09:11:24 UTC

    
Comment 1 Thomas Hackert 2014-04-06 16:34:18 UTC Comment hidden (obsolete)
Comment 2 Kevin Suo 2014-04-07 13:19:34 UTC
I tested in both LibreOffice Calc and Writer, the touchpad two-finger-scrolling works as expected.

Fedora 20 x86, Lenovo R61i, LibreOffice 4.2.3.3

As the bug reporter reported the OS as Windows, should someone test it under Windows also?
Comment 3 roee 2014-04-07 13:46:01 UTC Comment hidden (obsolete)
Comment 4 Kevin Suo 2014-04-07 16:03:34 UTC Comment hidden (no-value)
Comment 5 Kevin Suo 2014-04-07 16:15:05 UTC Comment hidden (no-value)
Comment 6 roee 2014-04-07 16:25:13 UTC
I'm sorry, no, I think you're incorrect.  It is not a touch pad issue, and the behavior you're describing is not what's expected.

The expected behavior (standard across all applications and all platforms) is that a two-finger scroll on a touch pad drags the sheet, NOT the scroll bar.  Remember that the sheet and the scroll bar move in opposite directions from each other.  With a two-finger scroll on a touch pad, the expected behavior is that the sheet moves in the direction of the gesture, which means the scroll bars move in the opposite direction.

This is standard across all applications, and in fact LibreOffice does it correctly in the vertical axis.  It's only in the horizontal axis that LibreOffice has it wrong.  This is a bug, and needs to be fixed for LibreOffice to be 1) self-consistent, and 2) consistent with expected behavior across all applications.

I will again describe the behavior, this time including also the behavior of the scroll bars for further clarity.  Please read this carefully:

To reproduce:

Open any LibreOffice application.  Perhaps Draw makes this most clear.

First let's demonstrate two-finger scrolling in the vertical axis, which works as expected:

- On the touch pad, perform a two-finger scrolling gesture in an upwards direction.  --> The vertical scroll bar moves down and the sheet moves up, bringing a part of the sheet from further down into view.  This is as expected.

- On the touch pad, perform a two-finger scrolling gesture in a downwards direction.  --> The vertical scroll bar moves up and the sheet moves down, bringing a part of the sheet from further up into view.  This is as expected.

Now do the same test with two-finger scrolling in the horizontal axis, which doesn't work as expected:

- On the touch pad, perform a two-finger scrolling gesture from left to right.  --> The horizontal scroll bar moves right and the sheet moves left, bringing a part of the sheet from further right into view.  This is opposite of what is expected.

- On the touch pad, perform a two-finger scrolling gesture from right to left.  --> The horizontal scroll bar moves left and the sheet moves right, bringing a part of the sheet from further left into view.  This is opposite of what is expected.
Again, the expected behavior, in either axis, is that the sheet moves with the gesture, not the scroll bar.
Comment 7 roee 2014-04-07 16:28:22 UTC Comment hidden (no-value)
Comment 8 Joel Madero 2014-04-10 00:12:26 UTC Comment hidden (obsolete)
Comment 9 Jean-Baptiste Faure 2014-05-01 16:36:55 UTC Comment hidden (off-topic)
Comment 10 roee 2014-05-01 18:10:39 UTC
Yes, there is a setting in Windows to globally reverse the direction.  However, this not the point.  Whichever way Windows is configured, LibreOffice will behave the opposite way of all other applications under that configuration.  So I can reverse the global setting in Windows to make LibreOffice behave "correctly", but then all other applications behave incorrectly.

To re-iterate, we don't need to debate which direction is "right" or "wrong".  As you pointed out, that preference can be changed in a global setting in the OS.  The problem is the inconsistency among applications -- that LibreOffice does the opposite of all other applications.

Cheers,
-Roee


(In reply to comment #9)
> (In reply to comment #6)
> > [...]
> > The expected behavior (standard across all applications and all platforms)
> > is that a two-finger scroll on a touch pad drags the sheet, NOT the scroll
> > bar. 
> 
> This behavior is configurable on my touchpad under Linux. I guess it is
> configurable on Windows too.
> 
> Best regards. JBF
Comment 11 Buovjaga 2014-10-31 20:26:26 UTC
On a Lenovo T520 with Win 7, two-finger scrolling in Firefox scrolls vertically exactly like LO and Windows file explorer (fingers down, scrollbar down..). Horizontal scrolling in LO, however, does not do anything.
In Firefox as in file explorer, horizontal scrolling left moves the scrollbar left, right moves the bar right.

So it seems the reporter's claim of standard behavior does not hold water. The behavior is apparently device-specific or OS-specific.

At least on my Lenovo, two-finger scrolling is not about moving freely on a canvas in 4 directions. It is simply scrolling, like the name and the cursor helpers imply.
Comment 12 Robinson Tryon (qubit) 2015-03-16 04:12:52 UTC Comment hidden (obsolete)
Comment 13 QA Administrators 2015-10-14 19:50:24 UTC Comment hidden (obsolete)
Comment 14 roee 2015-10-15 01:37:28 UTC
As I've already described previously, no, what I'm seeing contradicts what Beluga reported in Firefox, as well as in Windows File Explorer.

I'm currently using Firefox version 41.0.1.  And the correct behavior as I've described has been unchanged with every version for at least the past couple of years.

Likewise with Adobe Acrobat (currently version 15.9.20069.159242)

Likewise with Internet Explorer (currently version 11.0.9600.18036)

Likewise with any other common piece of software I could think to try.  Take your pick.  Only LibreOffice is the oddball exception that doesn't work correctly.
Comment 15 Joel Madero 2015-10-15 01:42:56 UTC Comment hidden (obsolete)
Comment 16 Jean-Baptiste Faure 2016-01-28 11:20:13 UTC
Seems to be confirmed and fixed:
https://gerrit.libreoffice.org/gitweb?p=core.git;a=commitdiff;h=b083afac2f0531bacd790cb3ac25353f9a02db5d

Best regards. JBF
Comment 17 tommy27 2016-11-30 05:07:51 UTC Comment hidden (obsolete)
Comment 18 Marlen 2018-06-04 20:02:40 UTC
The horizontal scroll direction is non-standard (reversed from all other Windows applications).

Test:
Open LibreOffice Calc. 
 1. scroll vertically - it will match the behaviour of the UI of other Programs in Windows.
 2. scroll horizontally - it will be the reverse of all other UIs of other Programs in Windows.

NOTE: this is independent of Global User settings on scroll direction (reversed vs. natural scrolling). LibreOffice Calc is _always_ the opposite of all other applications.
Comment 19 Xisco Faulí 2018-06-05 08:50:26 UTC Comment hidden (obsolete)
Comment 20 Buovjaga 2018-06-05 09:58:27 UTC Comment hidden (obsolete)
Comment 21 roee 2018-06-05 16:58:42 UTC Comment hidden (obsolete)
Comment 22 Buovjaga 2018-06-05 17:11:46 UTC
It is true, the code change only affects GTK3.
Comment 23 Rahul K 2018-10-22 17:52:12 UTC
It would be great if enabling scroll comes a modifiable setting. Users can customize so that no one feels scroll behavior is odd.
Comment 24 nokidding 2019-02-11 10:31:44 UTC
The alleged bug still persists in LO 6.2 beta... To reiterate, global OS settings (Linux Mint) for scrolling go one way, LO follows the opposite way, which is rather annoying but not an impossible thing to live with.
Comment 25 Luke 2019-03-18 23:15:28 UTC
Steps to Reproduce:
1. With a LO Writer or  Calc document, zoom in and/or resize your window to show horizontal scroll bars.
2. Two-finger drag from right to left

Expected Results:
1. Document scrolls to the right

Actual results:
1. Document scrolls to the left


This appears to be a problems with Synaptics touchpad drivers found in Lenovo laptops. I could reproduce this on my T440. I could not reproduce this on my Asus laptop with Asus drivers nor on my Dell with MS precision touchpad drivers.

With my T440, Word, Excel, MS Paint, Firefox, Chrome, Photoshop, WordPerfect, Notepad all 2-finger scroll correctly. LibreOffice is the only application that does not respect the drivers settings. 

See Also: https://ask.libreoffice.org/en/question/155824/two-finger-horizontal-scroll-does-not-reverse/
Comment 26 Luke 2019-03-19 01:54:04 UTC
On ubuntu 18.04 with the libinput driver, I tested all 3 laptops. All of them had the correct horizontal scrolling behavior. 

So lets track the Windows / Synaptics issue here.

nokidding,
Can you file a new bug report and give as much info as possible. Need to know what touchpad hardware you have, what driver (libinput or synaptics), and what VCL backend (gtk or gtk3) you are using.
Comment 27 Buovjaga 2019-08-05 13:32:50 UTC
(In reply to Luke from comment #26)
> On ubuntu 18.04 with the libinput driver, I tested all 3 laptops. All of
> them had the correct horizontal scrolling behavior. 
> 
> So lets track the Windows / Synaptics issue here.
> 
> nokidding,
> Can you file a new bug report and give as much info as possible. Need to
> know what touchpad hardware you have, what driver (libinput or synaptics),
> and what VCL backend (gtk or gtk3) you are using.

nokidding was not in CC, so asking again.

We are getting new reports against Linux, though (gtk2): bug 126680
Comment 28 gym 2019-08-14 13:24:57 UTC Comment hidden (off-topic)
Comment 29 Ted Lee 2019-08-16 21:49:58 UTC Comment hidden (off-topic)
Comment 30 Luke 2019-08-16 22:41:54 UTC
Gym and Ted see Bug 126680. The 6.3.0.4 issue on Mac OS should have been fixed there. It was backported to 6.3.1.
Comment 31 Ted Lee 2019-08-17 01:02:57 UTC Comment hidden (off-topic)